portfolio/urls.py
from portfolio_app.views import deleteView
from django.contrib import admin
from django.urls import path
from portfolio_app import views
from django.conf.urls import url,include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    url(r'^$',views.index,name='index'),
    url(r'projectPage/',views.projectPage,name='projectPage'),
    path('admin/', admin.site.urls),
    path(r'^deleteView/<int:i>/',views.deleteView,name='deleteView'),
    path(r'^project_detail/<int:i>/',views.project_detail,name="project_detail"),
    url(r'^projects/', include("portfolio_app.urls")),
    url(r'^logout/$',views.user_logout,name='logout'),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

portfolio_app/urls.py
from django.urls import path
from django.conf.urls import url
from . import views

app_name = 'portfolio_app'
urlpatterns = [
     url(r'^user_login/$',views.user_login,name='user_login'),
    url(r'^project_data/$',views.project_data,name ="project_data"),
    url(r'^signup/$',views.register,name ='signup'),
]

portfolio_app/models.py
from django.db import models
from django.contrib.auth.models import User
# Create your models here.
class ProjectInfo(models.Model):
    title = models.CharField(max_length=100)
    description = models.TextField()
    technology = models.CharField(max_length=20)
    image = models.ImageField(upload_to='img')

class portfolioList(models.Model):
     user = models.OneToOneField(User,on_delete=models.CASCADE,)   

portfolio_app/forms.py
from django import forms
from django.contrib.auth.models import User
from portfolio_app.models import ProjectInfo,portfolioList


class ProjectInfoForm(forms.ModelForm):
    class Meta():
        model = ProjectInfo
        fields = ('title','description','technology','image')

class UserForm(forms.ModelForm):
    password = forms.CharField(widget=forms.PasswordInput())

    class Meta():
        model = User
        fields = ('username','email','password')

portfolio_app/views.py
from django.http.response import HttpResponseRedirect, HttpResponse
from django.urls.base import reverse
from portfolio_app.models import ProjectInfo
from django.shortcuts import render
from portfolio_app.forms import ProjectInfoForm,UserForm
from django.contrib.auth import authenticate,login,logout
from django.contrib.auth.decorators import login_required
# Create your views here.

def index(request):
    return render(request, 'portfolio_app/index.html')


def project_detail(request,i):
    project = ProjectInfo.objects.get(id=i)
    context = {'project_detail': project}
    return render(request, 'portfolio_app/project_detail.html', context)

def project_data(request):
    
    if request.method == 'POST':
        addproject =ProjectInfoForm(data=request.POST,files=request.FILES)
        if addproject.is_valid():
            addproject.save()
            return HttpResponseRedirect(reverse('projectPage'))

        else:
            print(addproject.errors)
     
    else:
        addproject =ProjectInfoForm()
    return render(request,'portfolio_app/project_data.html',{'addproject': addproject})


def deleteView(request,i):
    y = ProjectInfo.objects.get(id= i)
    y.delete()
    return HttpResponseRedirect(reverse('projectPage'))



@login_required
def user_logout(request):
    logout(request)
    return HttpResponseRedirect(reverse('index'))



def register(request):
     registered = False
     
     if request.method == "POST":
         user_form = UserForm(data=request.POST)
         

         if user_form.is_valid():
             user =user_form.save()
             user.set_password(user.password)
             user.save()

             registered = True
         else:
            print(user_form.errors)
     else:
         user_form = UserForm()
         
    
     return render(request,'portfolio_app/signup.html',{'user_form': user_form,'registered':registered})


def user_login(request):
    if request.method == 'POST':
        username =request.POST.get('username')
        password = request.POST.get('password')

        user = authenticate(username=username,password=password)

        if user:
            if user.is_active:
                login(request,user)
                return HttpResponseRedirect(reverse('projectPage'))

            else:
                return HttpResponse("Account Not Active")
        else:
            print("Username: {} and password {}".format(username,password))
            return HttpResponse("invalid login details supplied!")

    else:
        return render(request,'portfolio_app/login.html',{})


def projectPage(request):
    projects = ProjectInfo.objects.all()
    context = {'projects': projects}
    return render(request, 'portfolio_app/projectPage.html', context)

templates/portfolio_app/base.html
<!DOCTYPE html>
{% load static %}
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Portfolio</title>
    <link rel="stylesheet" href="{% static 'css/style.css' %}">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <div class="container">
            <a class="navbar-brand" href="{% url 'index' %}">Portfolio</a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav mr-auto">
               
                
                 
                    
                {% if user.is_authenticated %}
                <li class="nav-item active">
                    <a class="nav-link" href="{% url 'admin:index' %}">Admin Login</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link active" aria-current="page" href="{% url 'logout' %}">Logout</a>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                      Project
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                      <a class="dropdown-item" href="{% url 'projectPage' %}">Project Page</a>
                      <a class="dropdown-item" href="{% url 'portfolio_app:project_data' %}">Add Project</a>
                    </div>
                  </li>
                
                {% else %}
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                      Login
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                      <a class="dropdown-item" href="{% url 'portfolio_app:user_login' %}">Login</a>
                      <a class="dropdown-item" href="{% url 'admin:index' %}">Admin Login</a>
                    </div>
                </li>
                <li class="nav-item">
                    <a class="nav-link active" aria-current="page" href="{% url 'portfolio_app:signup' %}">SignUp</a>
                </li>
                {% endif %}
            </ul>
            </div>
        </div>

    </nav>

    <div class="container">
        {% block body_block %}
        {% endblock %}
    </div>

    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script>

</body>
</html>

templates/portfolio_app/index.html
{% extends "portfolio_app/base.html" %}
{% load static %}
{% block body_block %}
<div class="jumbotron jumbotron-fluid">
    <div class="container">
      <h1 class="display-4">WELCOME TO THE PROJECT PORTFOLIO </h1>
      <p class="lead">You just login and see your Portfolio</p>
    </div>
</div>

{% endblock %}

templates/portfolio_app/login.html
{% extends 'portfolio_app/base.html' %}
{% block body_block %}

<div class="jumbotron">
    <h1>Please Login</h1>
    <form action="{% url 'portfolio_app:user_login' %}" method="POST">
        {% csrf_token %}
        <div class="form-group">
          <label for="username">Username:</label>
          <input type="text" name="username" class="form-control" id="username" aria-describedby="emailHelp" placeholder="Enter Username">
          <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone else.</small>
        </div>
        <div class="form-group">
          <label for="password">Password:</label>
          <input type="password" name="password" class="form-control" id="exampleInputPassword1" placeholder="Password">
        </div>
        <div class="form-check">
          <input type="checkbox" class="form-check-input" id="exampleCheck1">
          <label class="form-check-label" for="exampleCheck1">Check me out</label>
        </div>
        <input type="submit" name="" value="Login">
      </form>
</div>
{% endblock %}

templates/portfolio_app/projectPage.html
{% extends "portfolio_app/base.html" %}
{% load static %}
{% block body_block %}
<h1>Projects</h1>
<div class="row">
    {% for project in projects %}
    <div class="col-md-4">
        <div class="card mb-2">
            <img class="card-img-top" src="{{ project.image.url }}">
            <div class="card-body">
                <h5 class="card-title">{{ project.title }}</h5>
                <p class="card-text">{{ project.description }}</p>
                <a href="{% url 'project_detail' project.id %}"
                   class="btn btn-primary">
                    ReadMore</a>
                <a href="{% url 'deleteView' project.id %}"
                   class="btn btn-primary">
                    Delete</a>
                
            </div>
        </div>
    </div>
    {% endfor %}
</div>
{% endblock %}

templates/portfolio_app/project_data.html
{% extends "portfolio_app/base.html" %}
{% load static %}


{% block body_block %}

<div class="jumbotron">
    <h3>Fill out The Form</h3>

    <form enctype="multipart/form-data" method="POST">
        {% csrf_token %}
        {{ addproject.as_p }}
        <input type="submit" name="" value="Submit">

    </form>
    
</div>
{% endblock %}

templates/portfolio_app/project_detail.html
{% extends "portfolio_app/base.html" %}
{% load static %}

{% block body_block %}
<h1>{{ project_detail.title }}</h1>
<div class="row">
    <div class="col-md-8">
        <img src="{{ project_detail.image.url }}" alt="" width="100%">
    </div>
    <div class="col-md-4">
        <h5>About the project:</h5>
        <p>{{ project_detail.description }}</p>
        <br>
        <h5>Technology used:</h5>
        <p>{{ project_detail.technology }}</p>
    </div>
</div>
{% endblock %}

templates/portfolio_app/signup.html
{% extends "portfolio_app/base.html" %}
{% load static %}


{% block body_block %}

<div class="jumbotron">
    {% if registered %}
    <h1>Thank You For Registering!</h1>
    {% else %}
    <h1>Register Here!</h1>
    <h3>Fill out The Form</h3>

    <form enctype="multipart/form-data" method="POST">
        {% csrf_token %}
        {{ user_form.as_p }}
        <input type="submit" name="" value="Register">

    </form>
    {% endif %}
</div>
{% endblock %}